/**
* @par Copyright (C): 2010-2019, Shenzhen Yahboom Tech
* @file         tracking.c
* @author       Danny
* @version      V1.0
* @date         2017.08.16
* @brief        Ѳʵ
* @details
* @par History  ˵
*
*/
#include "STC12C5A60S2.H"

//
sbit Left_motor_go=P2^1;	   //ǰAIN2
sbit Left_motor_back=P2^2;	   //AIN1
sbit Right_motor_go=P2^4;	   //ҵǰBIN2
sbit Right_motor_back=P2^3;	   //ҵBIN1
sbit Left_motor_pwm=P2^0;	   //PWMA
sbit Right_motor_pwm=P2^5;	   //ҵPWMB

//Ŷ
sbit key = P2^7;


//Ĭϸߵƽᵼµ̽յƣԳнõ͵ƽ
sbit LED_R = P4^6;	//LED_RSTC12C5A60S2EAP4^6ܽ
sbit LED_G = P4^5;  //LED_GSTC12C5A60S2ALEP4^5ܽ
sbit LED_B = P4^4;	//LED_BSTC12C5A60S2PSENP4^4ܽ

//ѭŶ
//TrackSensorLeftPin1 TrackSensorLeftPin2 TrackSensorRightPin1 TrackSensorRightPin2
//      P1.1               P1.0                 P1.2                  P1.3
sbit TrackSensorLeftPin1  =  P1^1;   //ߵһѭ⴫ΪP1.1
sbit TrackSensorLeftPin2  =  P1^0;   //ߵڶѭ⴫ΪP1.0
sbit TrackSensorRightPin1 =  P1^2;   //ұߵһѭ⴫ΪP1.2
sbit TrackSensorRightPin2 =  P1^3;   //ұߵڶѭ⴫ΪP1.3

//ѭŲɼݵı
unsigned char TrackSensorLeftValue1;
unsigned char TrackSensorLeftValue2;
unsigned char TrackSensorRightValue1;
unsigned char TrackSensorRightValue2;

unsigned char pwm_val_left  =0;     //
unsigned char pwm_val_right =0;

//ٶȵڱ 0-20,0С,20
unsigned char push_val_left =5; //ռձpush_val_left/20 
unsigned char push_val_right=5; //ҵռձpush_val_right/20 

bit Right_PWM_ON=1;	            //ҵPWM
bit Left_PWM_ON =1;			    //PWM

/**
* Function       delay
* @author        Danny
* @date          2017.08.16
* @brief         ʱ
* @param         xmsʱʱ䣨ms
* @retval        void
* @par History   
*/	
void delay(unsigned int xms)				
{
    unsigned int i,j;
	for(i=xms;i>0;i--)		      
    for(j=900;j>0;j--);
}

/**
* Function       pwm_out_left_motor
* @author        Danny
* @date          2017.08.16
* @brief         	,push_val_leftֵıת,ռձ
* @param         void
* @retval        void
* @par History   
*/                                        
void pwm_out_left_motor(void)
{  
     if(Left_PWM_ON)
     {
          if(pwm_val_left<=push_val_left)
	      {
	          Left_motor_pwm =1; 
	      }
	      else 
	      {
	           Left_motor_pwm=0;
          }
          if(pwm_val_left>=20) //20pwmΪ20ms50hz
	      pwm_val_left=0;
     }
     else    
     {
          Left_motor_pwm=0;   //δPWMPWMA=0 ֹͣ
     }
}

/**
* Function       pwm_out_right_motor
* @author        Danny
* @date          2017.08.16
* @brief         ҵ	,pwm_val_rightֵıת,ռձ
* @param         void
* @retval        void
* @par History   
*/  
void pwm_out_right_motor(void)
{ 
    if(Right_PWM_ON)
    { 
        if(pwm_val_right<=push_val_right)	
	    {
	        Right_motor_pwm=1; 							
        }
	    else 
	    {
	        Right_motor_pwm=0;
        }
	    if(pwm_val_right>=20) //20pwmΪ20ms50hz
	    pwm_val_right=0;
    }
    else    
    {
        Right_motor_pwm=0;	  //δPWMPWMB=0ҵֹͣ
    }
}

/**
* Function       run
* @author        Danny
* @date          2017.08.16
* @brief         Сǰ
* @param[in1]    left_speed:ٶ
* @param[in2]    right_speed:ٶ
* @param[out]    void
* @retval        void
* @par History   
*/
void run(int left_speed, int right_speed)
{
  //ǰ
  Left_motor_go = 1;   //ǰʹ
  Left_motor_back = 0; //˽ֹ
  //ָܽŵPWMֵĿʵֿ٣0-20
  push_val_left=left_speed;
	 
  //ҵǰ
  Right_motor_go=1;   //ҵǰʹ
  Right_motor_back=0; //ҵ˽ֹ
  //ָܽŵPWMֵĿʵֿ٣0-20
  push_val_right=right_speed;
  
  return;
}

/**
* Function       left
* @author        Danny
* @date          2017.08.16
* @brief         Сת ת(ֲ,ǰ)
* @param[in1]    left_speed:ٶ
* @param[in2]    right_speed:ٶ
* @param[out]    void
* @retval        void
* @par History   
*/
void left(int left_speed, int right_speed)
{
  	//ֹͣ
  	Left_motor_go = 0;   //ǰֹ
  	Left_motor_back = 0; //˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
  	push_val_left=left_speed;
	 
  	//ҵǰ
  	Right_motor_go=1;   //ҵǰʹ
  	Right_motor_back=0; //ҵ˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
  	push_val_right=right_speed;
  
  	return;
}

/**
* Function       right
* @author        Danny
* @date          2017.08.16
* @brief         Сת ת(ǰ,ֲ)
* @param[in1]    left_speed:ٶ
* @param[in2]    right_speed:ٶ
* @param[out]    void
* @retval        void
* @par History   
*/
void right(int left_speed, int right_speed)
{
  	//ǰ
  	Left_motor_go = 1;   //ǰʹ
  	Left_motor_back = 0; //˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
  	push_val_left=left_speed;
	 
  	//ҵֹͣ
  	Right_motor_go=0;   //ҵǰֹ
  	Right_motor_back=0; //ҵ˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
  	push_val_right=right_speed;
  
  	return;
}

/**
* Function       spin_left
* @author        Danny
* @date          2017.08.16
* @brief         Сԭת ԭת(ֺˣǰ)
* @param[in1]    left_speed:ٶ
* @param[in2]    right_speed:ٶ
* @param[out]    void
* @retval        void
* @par History   
*/
void spin_left(int left_speed, int right_speed)
{
  	//
  	Left_motor_go = 0;   //ǰֹ
  	Left_motor_back = 1; //ʹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
  	push_val_left=left_speed;
	 
  	//ҵǰ
  	Right_motor_go=1;   //ҵǰʹ
  	Right_motor_back=0; //ҵ˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
  	push_val_right=right_speed;
  
  	return;
}

/**
* Function       spin_right
* @author        Danny
* @date          2017.08.16
* @brief         Сԭת ԭת(ֺˣǰ)
* @param[in1]    left_speed:ٶ
* @param[in2]    right_speed:ٶ
* @param[out]    void
* @retval        void
* @par History   
*/
void spin_right(int left_speed, int right_speed)
{
  	//ǰ
  	Left_motor_go = 1;   //ǰʹ
  	Left_motor_back = 0; //˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
  	push_val_left=left_speed;
	 
  	//ҵ
  	Right_motor_go=0;   //ҵǰֹ
  	Right_motor_back=1; //ҵʹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
  	push_val_right=right_speed;
  
  	return;
}

/**
* Function       key_scan
* @author        Danny
* @date          2017.08.16
* @brief         (ȥ)
* @param[in]     void
* @param[out]    void
* @retval        void
* @par History   
*/
void key_scan(void)
{
  	while (key!=0);       //ûбһֱѭ
  	while (key==0)        //ʱ
  	{
    	delay(10);	      //ʱ10ms
    	if (key==0)       //ڶжϰǷ񱻰
    	{    
      		delay(100);   
      		while (key==0);  //жϰǷɿ    
    	}    
  	}
}

/**
* Function       timer0
* @author        Danny
* @date          2017.08.16
* @brief         TIMER0жϷӺPWMźţ
* @param[in]     void
* @param[out]    void
* @retval        void
* @par History   
*/
void timer0()interrupt 1 using 2
{
     TH0=0XFC;	      //1Msʱ
	 TL0=0X66;
	 pwm_val_left++;
	 pwm_val_right++;
	 pwm_out_left_motor();
	 pwm_out_right_motor();
}

 /**
* Function       main
* @author        Danny
* @date          2017.08.16
* @brief         ȵðɨ躯
*                ѭģʽ
* @param[in]     void
* @retval        void
* @par History   
*/
void main()
{

//Ĭϸߵƽᵼµ̽յƣԳнõ͵ƽ

    //P4ΪͨIOʹ
	P4SW |= (1<<4);
	P4SW |= (1<<5);
	P4SW |= (1<<6);
	
	//P4Ϊǿģʽ
	P4M1 &= ~(1<<4); 
	P4M1 &= ~(1<<5);
	P4M1 &= ~(1<<6);

   	P4M0 |= (1<<4);
   	P4M0 |= (1<<5);
   	P4M0 |= (1<<6);

	LED_R=0;
	LED_G=0;   
	LED_B=0;


    P2=0XC0;    //ص	
	TMOD=0X01;  //ʱʽ1
    TH0=0XFC;   //1msʱװֵ
    TL0=0X66;
    TR0=1;		//T0
    ET0=1;		//T0ж
	EA =1;	    //ж 
   
    //ðɨ躯
    key_scan();
    while(1)
	{
    	//⵽ʱѭģӦָʾ˿ڵƽΪ0
   		//δ⵽ʱѭģӦָʾ𣬶˿ڵƽΪ1
   		TrackSensorLeftValue1  = TrackSensorLeftPin1;
   		TrackSensorLeftValue2  = TrackSensorLeftPin2;
   		TrackSensorRightValue1 = TrackSensorRightPin1;
   		TrackSensorRightValue2 = TrackSensorRightPin2;

   		//·ѭŵƽ״̬
   		// 0 0 X 0
   		// 1 0 X 0
   		// 0 1 X 0
   		//6ֵƽ״̬ʱСԭתٶΪ20,ʱ80ms
   		//Ǻֱǵת
   		if ( (TrackSensorLeftValue1 == 0 || TrackSensorLeftValue2 == 0) &&  TrackSensorRightValue2 == 0)
   		{
     		spin_right(12, 12);
     		delay(80);
   		}
   		//·ѭŵƽ״̬
   		// 0 X 0 0       
   		// 0 X 0 1 
   		// 0 X 1 0       
   		//Ǻֱǵת
   		else if ( TrackSensorLeftValue1 == 0 && (TrackSensorRightValue1 == 0 ||  TrackSensorRightValue2 == 0))
   		{
     		spin_left(12, 12);
     		delay(80);
   		}
   		// 0 X X X
   		//߼⵽
   		else if ( TrackSensorLeftValue1 == 0)
   		{
     		spin_left(11, 11);
     		//delay(10);
   		}
   		// X X X 0
   		//ұ߼⵽
   		else if ( TrackSensorRightValue2 == 0 )
   		{
     		spin_right(11, 11);
     		//delay(10);
   		}
   		//·ѭŵƽ״̬
   		// X 0 1 X
   		//С
   		else if ( TrackSensorLeftValue2 == 0 && TrackSensorRightValue1 == 1)
   		{
     		left(0, 10);
   		}
   		//·ѭŵƽ״̬
   		// X 1 0 X  
   		//С
   		else if (TrackSensorLeftValue2 == 1 && TrackSensorRightValue1 == 0)
   		{
     		right(10, 0);
   		}
   		//·ѭŵƽ״̬
   		// X 0 0 X
   		//ֱ
   		else if (TrackSensorLeftValue2 == 0 && TrackSensorRightValue1 == 0)
   		{
     		run(12, 12);
   		}
   		//Ϊ1 1 1 1ʱСһС״̬
 	}
 	return;
}
